﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

namespace NewAgeDesign.FileManager.jsTree
{
	public partial class server : System.Web.UI.Page
	{
        public struct attrTreeNode
        {
            public string id;
        }

        public struct TreeNode
        {
            public string data;    //node title
            public string state;   //estado
            public attrTreeNode attr;      //node identification
        }

        public struct AjaxResponse
        {
            public bool status;
            public string id;

            public AjaxResponse(bool s, string id)
            {
                this.status = s;
                this.id = id;
            }
        }

		protected void Page_Load(object sender, EventArgs e)
		{
            string result = String.Empty;
            switch(Request.Params["operation"])
            {
                case "get_children":
                    result = GetChildren(Request);
                    break;
                case "create_node":
                    result = CreateNode(Request);
                    break;
                case "remove_node":
                    result = RemoveNode(Request);
                    break;
                case "rename_node":
                    result = RenameNode(Request);
                    break;
            }

            Response.Write(result);
            Response.End();
        }

        private string CreateNode(HttpRequest request)
        {
            string id = request.Params["id"];
            string position = request.Params["position"];
            string title = request.Params["title"];
            string type = request.Params["type"];

            string dir = Server.MapPath("\\" + id);
            Directory.CreateDirectory(Path.Combine(dir, title));

            return ToJSON(new AjaxResponse(true, Path.Combine(id, title)));
        }

        private string RemoveNode(HttpRequest request)
        {
            string id = request.Params["id"];

            string dir = Server.MapPath("\\" + id);
            try
            {
                Directory.Delete(dir, true);
            }
            catch (IOException)
            {
                System.Threading.Thread.Sleep(100);
                Directory.Delete(dir, true);
            }

            return ToJSON(new AjaxResponse(true, null));
        }

        private string RenameNode(HttpRequest request)
        {
            string id = request.Params["id"];
            string title = request.Params["title"];

            string dir = Server.MapPath("\\" + id);
            DirectoryInfo dInfo = new DirectoryInfo(dir);
            string dir2 = Path.Combine(dInfo.Parent.FullName, title);
            Directory.Move(dir, dir2);

            return ToJSON(new AjaxResponse(true, null));
        }

        private string GetChildren(HttpRequest request)
        {
            string dir = "\\" + Server.UrlDecode(Request.Params["id"]);
            if (dir == "\\null") dir = "";

            string raiz = Server.MapPath("/");
            string absoluteDir = Server.MapPath("\\" + dir);

            List<TreeNode> result = new List<TreeNode>();

            foreach (string directory in Directory.GetDirectories(absoluteDir))
            {
                string dirName = new DirectoryInfo(directory).Name;
                if (dirName.StartsWith("_")) continue;
                if (dirName.Equals(".svn")) continue;

                result.Add(new TreeNode() {
                    attr = new attrTreeNode() {
                        id = directory.Replace(raiz, "")
                    },
                    data = dirName,
                    state = "closed"
                });
            }

            return ToJSON(result.ToArray());
		}


        static public string ToJSON(object obj)
        {
            System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            return serializer.Serialize(obj);
        }
	}
}